tbb::internal::FastRandom Class Reference

A fast random number generator. More...

`#include <tbb_misc.h>`

Collaboration diagram for tbb::internal::FastRandom:

## Public Member Functions

unsigned short | get ()
| Get a random number. More...
unsigned short | get (unsigned &seed)
| Get a random number for the given seed; update the seed for next use. More...
| FastRandom (void *unique_ptr)
| Construct a random number generator. More...
| FastRandom (uint32_t seed)
| FastRandom (uint64_t seed)
template<typename T >
void | init (T seed)
void | init (uint64_t seed, int_to_type< 8 >)
void | init (uint32_t seed, int_to_type< 4 >)

## Private Attributes

unsigned | x
unsigned | c

## Static Private Attributes

static const unsigned | a = 0x9e3779b1

## Detailed Description

A fast random number generator.

Uses linear congruential method.

Definition at line 135 of file tbb_misc.h.

## Constructor & Destructor Documentation

## FastRandom() [1/3]

tbb::internal::FastRandom::FastRandom | ( | void * | unique_ptr | ) |

inline

Construct a random number generator.

Definition at line 157 of file tbb_misc.h.

{ init(uintptr_t(unique_ptr)); }

References init().

Here is the call graph for this function:

## FastRandom() [2/3]

tbb::internal::FastRandom::FastRandom | ( | uint32_t | seed | ) |

inline

Definition at line 158 of file tbb_misc.h.

{ init(seed); }

References init().

Here is the call graph for this function:

## FastRandom() [3/3]

tbb::internal::FastRandom::FastRandom | ( | uint64_t | seed | ) |

inline

Definition at line 159 of file tbb_misc.h.

{ init(seed); }

References init().

Here is the call graph for this function:

## Member Function Documentation

## get() [1/2]

unsigned short tbb::internal::FastRandom::get | ( |  | ) |

inline

Get a random number.

Definition at line 146 of file tbb_misc.h.

{
return get(x);
}

References x.

Referenced by tbb::internal::random_lane_selector::operator()(), tbb::internal::task_stream< num_priority_levels >::push(), and tbb::internal::generic_scheduler::steal_task().

Here is the caller graph for this function:

## get() [2/2]

unsigned short tbb::internal::FastRandom::get | ( | unsigned & | seed | ) |

inline

Get a random number for the given seed; update the seed for next use.

Definition at line 150 of file tbb_misc.h.

{
unsigned short r = (unsigned short)(seed>>16);
__TBB_ASSERT(c&1, "c must be odd for big rng period");
seed = seed*a+c;
return r;
}

References __TBB_ASSERT, a, and c.

## init() [1/3]

template<typename T >

void tbb::internal::FastRandom::init | ( | T | seed | ) |

inline

Definition at line 161 of file tbb_misc.h.

{
init(seed,int_to_type<sizeof(seed)>());
}

Referenced by FastRandom(), and init().

Here is the caller graph for this function:

## init() [2/3]

void tbb::internal::FastRandom::init | ( | uint32_t | seed,
|  | int_to_type< 4 > |
| ) |  |

inline

Definition at line 167 of file tbb_misc.h.

{
#if __TBB_OLD_PRIMES_RNG
x = seed;
a = GetPrime( seed );
#else
// threads use different seeds for unique sequences
c = (seed|1)*0xba5703f5; // c must be odd, shuffle by a prime number
x = c^(seed>>1); // also shuffle x for the first get() invocation
#endif
}

References a, c, tbb::internal::GetPrime(), and x.

Here is the call graph for this function:

## init() [3/3]

void tbb::internal::FastRandom::init | ( | uint64_t | seed,
|  | int_to_type< 8 > |
| ) |  |

inline

Definition at line 164 of file tbb_misc.h.

{
init(uint32_t((seed>>32)+seed), int_to_type<4>());
}

References init().

Here is the call graph for this function:

## Member Data Documentation

## a

const unsigned tbb::internal::FastRandom::a = 0x9e3779b1

static private

Definition at line 142 of file tbb_misc.h.

Referenced by get(), and init().

## c

unsigned tbb::internal::FastRandom::c

private

Definition at line 141 of file tbb_misc.h.

Referenced by get(), and init().

## x

unsigned tbb::internal::FastRandom::x

private

Definition at line 141 of file tbb_misc.h.

Referenced by get(), and init().

The documentation for this class was generated from the following file:

- tbb_misc.h

tbb::internal::FastRandom::x
unsigned x
Definition: tbb_misc.h:141
tbb::internal::GetPrime
unsigned GetPrime(unsigned seed)
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::internal::FastRandom::init
void init(T seed)
Definition: tbb_misc.h:161
tbb::internal::FastRandom::get
unsigned short get()
Get a random number.
Definition: tbb_misc.h:146
tbb::internal::FastRandom::a
static const unsigned a
Definition: tbb_misc.h:142
tbb::internal::FastRandom::c
unsigned c
Definition: tbb_misc.h:141

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.